> For the complete documentation index, see [llms.txt](https://docs-protocol.loopring.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs-protocol.loopring.io/resources/websocket/amm-pool-snapshot-notification.md).

# AMM Pool Snapshot Notification

### Rules <a href="#rules" id="rules"></a>

* Topic name: `ammpool`
* ApiKey requred: No
* <mark style="color:red;">**snapshot mode ONLY!**</mark>

### Parameters <a href="#parameters" id="parameters"></a>

<table><thead><tr><th>Parameter</th><th>Note</th><th data-hidden>Required</th><th data-hidden></th><th data-hidden></th></tr></thead><tbody><tr><td>poolAddress</td><td><a href="https://docs.loopring.io/en/dex_apis/getAmmPools.html">poolAddress</a></td><td>Y</td><td></td><td></td></tr></tbody></table>

### Status code <a href="#status-code" id="status-code"></a>

| Value  | Note                                  |
| ------ | ------------------------------------- |
| 102034 | receive illegal arg for topic ammpool |

### Notification example <a href="#notification-example" id="notification-example"></a>

```json
{
  "topic" : {
    "topic" : "ammpool",
    "poolAddress" : "0x18920d6E6Fb7EbE057a4DD9260D6D95845c95036",
    "snapshot" : true
  },
  "ts" : 1611267558234,
  "data" : [ [ "11792920485390000000000000", "3998385574130000000000" ], "41277091829000" ]

}
```

### Data Model <a href="#data-model" id="data-model"></a>

**Notification**

<table><thead><tr><th>Field</th><th>Type</th><th>Note</th><th data-hidden>Required</th></tr></thead><tbody><tr><td>topic</td><td>JSON</td><td>Topic and parameters</td><td>Y</td></tr><tr><td>ts</td><td>integer</td><td>Notification timestamp (milliseconds)</td><td>Y</td></tr><tr><td>data</td><td>[[string, string], string]</td><td>Amm snapshot array</td><td>Y</td></tr></tbody></table>

**PoolSnapshot**

<table><thead><tr><th>Index</th><th>Type</th><th>Note</th><th data-hidden>Required</th></tr></thead><tbody><tr><td>1</td><td>[string, string]</td><td>Token balance of in pool token pair, i.e. [base token amount, quote token amount]</td><td>Y</td></tr><tr><td>2</td><td>string</td><td>Token balance of pool's LP token</td><td>Y</td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs-protocol.loopring.io/resources/websocket/amm-pool-snapshot-notification.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
